Description

It's debatable whether this is a bug or not, but I think the current interrupt

handling behavior with IO.copy_stream is fragile and unpredictable, and

inconsistent with IO#read and IO#write.

This is to be consistent with IO#read and IO#write behavior

where rb_io_wait_readable() and rb_io_wait_writable() retry

on interrupt (EAGAIN/ERESTART) instead of returning a short

copy or raising Errno::EINTR.

Related issues:

Related to Ruby - Bug #4680: [PATCH] io.c: fix busy wait with sendfile() Closed 05/13/2011

History

#1 - 05/20/2011 08:23 AM - normalperson (Eric Wong)

Eric Wong normalperson@yhbt.net wrote:

Bug #4683: [PATCH] io.c: copy_stream execute interrupts and retry

http://redmine.ruby-lang.org/issues/4683

 It's debatable whether this is a bug or not, but I think the current interrupt

handling behavior with IO.copy_stream is fragile and unpredictable, and

inconsistent with IO#read and IO#write.

This is to be consistent with IO#read and IO#write behavior

where rb_io_wait_readable() and rb_io_wait_writable() retry

on interrupt (EAGAIN/ERESTART) instead of returning a short

copy or raising Errno::EINTR.

 Can I get a response on this soon?  I really want this issue resolved

before 1.9.3 because it's inconsistent with existing Ruby read/write

behavior and working around it painful.

A backport to 1.9.2 would be appreciated, too.

Thanks!

--

Eric Wong

#2 - 05/20/2011 02:46 PM - naruse (Yui NARUSE)

- Status changed from Open to Assigned

- Assignee set to akr (Akira Tanaka)

#3 - 05/28/2011 04:15 PM - akr (Akira Tanaka)

I think this is subtle but interesting issue.  Thank you.

I'm not sure rb_thread_interrupted() is callable without GVL.

kosaki pointed mutual exclusion issue with interrupt_flag.

http://redmine.ruby-lang.org/issues/4770
Since the experimental function rb_thread_call_with_gvl is not callable

with GVL, nogvl_copy_stream_continue_p is not callable with GVL.

So nogvl_copy_stream_continue_p is not callable from maygvl_* such as

maygvl_copy_stream_wait_read.

I guess maygvl_* functions needs has_gvl parameter to keep GVL status.

#4 - 05/29/2011 07:10 AM - akr (Akira Tanaka)

Hm.  rb_thread_interrupted() is safe to call from blocking region.

#5 - 05/29/2011 01:26 PM - akr (Akira Tanaka)

As far as I remember, io.c should not use vm_core.h and rb_thread_t.

ko1 dislikes it.

#6 - 05/29/2011 07:29 PM - akr (Akira Tanaka)

- File copy_stream_interrupt_handling.patch added

#7 - 05/31/2011 01:53 PM - normalperson (Eric Wong)

Akira Tanaka akr@fsij.org wrote:

As far as I remember, io.c should not use vm_core.h and rb_thread_t.

ko1 dislikes it.

 I think we can work around it by making more API methods public.

I have an old issue open to export rb_thread_call_with_gvl() for

extensions:

http://redmine.ruby-lang.org/issues/4328

Perhaps exec_interrupts() can be made into a public API method:

rb_thread_exec_interrupts_with_gvl()

--

Eric Wong

#8 - 06/02/2011 08:20 PM - akr (Akira Tanaka)

- File copy_stream_interrupt_handling-2.patch added

Adding public functions needs a discussion with ko1.

copy_stream_interrupt_handling-2.patch uses internal.h to share

declarations between io.c and thread.c.

#9 - 06/03/2011 01:53 AM - normalperson (Eric Wong)

Akira Tanaka akr@fsij.org wrote:

Issue #4683 has been updated by Akira Tanaka.

File copy_stream_interrupt_handling-2.patch added

 Patch looks good, thanks!  Can you please commit?

Adding public functions needs a discussion with ko1.

 I haven't seen any response for #4328 in months, though :(

--

Eric Wong

#10 - 06/14/2011 08:40 AM - akr (Akira Tanaka)

- Status changed from Assigned to Closed

Files

0001-io.c-copy_stream-execute-interrupts-and-retry.patch 4.02 KB 05/13/2011 normalperson (Eric Wong)
0002-test_io-add-test-for-copy_stream-failing-on-EINTR.patch 1.75 KB 05/13/2011 normalperson (Eric Wong)

copy_stream_interrupt_handling.patch 7.97 KB 05/29/2011 akr (Akira Tanaka)

copy_stream_interrupt_handling-2.patch 9.42 KB 06/02/2011 akr (Akira Tanaka)
